[RFC PATCH v9 7/7] perf test: Add test for Intel TPEBS counting mode

From: weilin . wang
Date: Tue May 21 2024 - 13:41:26 EST


From: Weilin Wang <weilin.wang@xxxxxxxxx>

Intel TPEBS sampling mode is supported through perf record. The counting mode
code uses perf record to capture retire_latency value and use it in metric
calculation. This test checks the counting mode code.

Signed-off-by: Weilin Wang <weilin.wang@xxxxxxxxx>
---
.../perf/tests/shell/test_stat_intel_tpebs.sh | 27 +++++++++++++++++++
1 file changed, 27 insertions(+)
create mode 100755 tools/perf/tests/shell/test_stat_intel_tpebs.sh

diff --git a/tools/perf/tests/shell/test_stat_intel_tpebs.sh b/tools/perf/tests/shell/test_stat_intel_tpebs.sh
new file mode 100755
index 000000000000..4cb749d84367
--- /dev/null
+++ b/tools/perf/tests/shell/test_stat_intel_tpebs.sh
@@ -0,0 +1,27 @@
+#!/bin/sh
+# test Intel TPEBS counting mode
+# SPDX-License-Identifier: GPL-2.0
+
+set e
+err=0
+
+# Use this event for testing because it should exist in all platforms
+e=cache-misses:R
+
+# Without this cmd option, default value or zero is returned
+echo "Testing without --enable-tpebs-recording"
+result=$(perf stat -e "$e" true 2>&1)
+[[ "$result" =~ "$e" ]] && err=0 || err=1
+
+if [[ "$err" == 1 ]]
+then
+ exit "$err"
+fi
+
+# In platforms that do not support TPEBS, it should execute without error.
+echo "Testing with --enable-tpebs-recording"
+result=$(perf stat -e "$e" --enable-tpebs-recording -a sleep 0.01 2>&1)
+[[ "$result" =~ "perf record" && "$result" =~ "$e" ]] && err=0 || err=1
+
+
+exit "$err"
--
2.43.0